#ifndef MOUSE_H
#define MOUSE_H

#include "../common/sources/system/cmaths.h"
#include <vector>

enum EMouseAreaTypes
{
    eMouseArea_Inventory = 0,
    eMouseArea_3DView,
    eMouseArea_Resurrect,
    eMouseArea_Eye,
    eMouseAreaG_Champion,
    eMouseAreaG_DoorButton
};

struct SMouseArea
{
    EMouseAreaTypes type;
    CRect   rect;
    void*   param1;
    void*   param2;
};

class CMouse
{
public:
    CMouse();

    void        update();
    void        clearAreas();
    void        addArea(EMouseAreaTypes type, CRect rect, void* param1 = NULL, void* param2 = NULL);
    SMouseArea* clickedArea();

    CVec2   mPos;
    bool    mButtonPressed;
    bool    mButtonPressing;
    bool    mButtonReleasing;

private:
    std::vector<SMouseArea>   mAreaList;
};

extern CMouse  mouse;

#endif // MOUSE_H
